/*Pekara organizuje nagradnu igru: Za svaki kupljen hleb i 2 peciva dobija se jedan bod. Prvog dana nagradne igre za
svakog kupca, se unose sledeći podaci: IME (jedna reč), B_HLEB (ceo broj), B_PECIVO (ceo broj), a B_POENA (ceo
broj) se određuje na osnovu kupovine.
 Formirati listu kupaca, ako se na ulazu zadaje broj kupaca prvog dana i na početku liste se nalazi prvi kupac.
 Ispisati listu kupaca.
 Narednog dana je u pekaru došlo K kupaca, neki koji su bili prethodnog dana i neki novi. Ako je IME kupca
jedinstven podataka, za kupce koji se već nalaze u listi se ažuriraju podaci na osnovu nove kupovine, a novi kupci
se dodaju na kraj liste.
 Ispisati novu listu kupaca.
 Nagradna igra traje D dana, D se zadaje na ulazu, i na kraju svakog dana se ispisuje lista kupaca.
 Nagradu dobija kupac koji je poslednji u listi i koji je sakupio bar B bodova, pri čemu se B zadaje na ulazu.*/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>


typedef struct kupac
{
	char ime[50];
	int b_hleb;
	int b_pecivo;
	int b_poena;
	struct kupac *sledeci;
}kupac;

#define novi(x) x=(kupac*)malloc(sizeof(kupac))


void dodaj(kupac **p, char ime[], int b_hleb, int b_pecivo, int b_poena);
kupac *form( int k);
void ispis(kupac *p);
void novi_form(kupac **p,char ime[], int b_hleb, int b_pecivo, int b_poena);





int main()
{
	char ime[50];
	int b_hleb;
	int b_pecivo;
	int b_poena;
	int m,s;
	int b;

	
	int k; //broj kupaca
	kupac *p=NULL;
	
	int d;
	printf("Unesite broj dana D\n");
	scanf("%d",&d);
	
	int i,j;
	
	printf("Unesite broj kupaca za prvi dan\n");
	scanf("%d",&k);
	p=form(k);
	ispis(p);
	
	for(i=0; i<d-1; i++)
	{
		printf("Unesite broj kupaca za novi dan\n");
		scanf("%d",&k);
		for(j=0; j<k; j++)
		{
			printf("Unesite podatke o novom kupcu\n");
			scanf("%s",ime);
			scanf("%d",&b_hleb);
			scanf("%d",&b_pecivo);
			m=b_hleb/1;
			s=b_pecivo/2;
			if(m < s) b_poena=m; else b_poena=s;
		
			novi_form(&p,ime,b_hleb,b_pecivo,b_poena);
		}
		ispis(p);
	}
	
	printf("Unesite b bodova\n");
	scanf("%d",&b);
	
	kupac *r=NULL;
	
	while(p->sledeci)
	{
		if(p->b_poena >= b) dodaj(&r,p->ime,p->b_hleb,p->b_pecivo,p->b_poena);
		p=p->sledeci;
	}
	
	if(r == NULL) printf("Nema pobednika\n");
	else
	{
		while(r->sledeci) r=r->sledeci;
	
		printf("Pobednik je %s\n",r->ime);
	
	}
	
	
	
	return 0;
}

void ispis(kupac *p)
{
	while(p)
	{
		printf("%s\t  %d\t   %d\t  %d\t",p->ime,p->b_hleb,p->b_pecivo,p->b_poena);
		printf("\n");
		p=p->sledeci;
	}
}

kupac *form( int k)
{
	char ime[50];
	int b_hleb;
	int b_pecivo;
	int b_poena;
	
	kupac *p=NULL;
	
	int i;
	int d,s;
	for(i=0; i<k;i++)
	{
		scanf("%s",ime);
		scanf("%d",&b_hleb);
		scanf("%d",&b_pecivo);
		
		d=b_hleb/1;
		s=b_pecivo/2;
		
		if(d < s) b_poena=d; else b_poena=s;

		
		dodaj(&p,ime,b_hleb,b_pecivo,b_poena);
	}
	
	return p;
}


void dodaj(kupac **p, char ime[], int b_hleb, int b_pecivo, int b_poena)
{
	kupac *pom=*p,*temp;
	
	novi(temp);
	if(!temp)
	{
		printf("Losa alokacija\n");
		exit(0);
	}
	
	strcpy(temp->ime,ime);
	temp->b_hleb=b_hleb;
	temp->b_pecivo=b_pecivo;
	temp->b_poena=b_poena;
	temp->sledeci=NULL;
	
	if( (*p) == NULL)	*p=temp;
	else
	{
		while(pom->sledeci) pom=pom->sledeci;
		pom->sledeci=temp;
	}
}


void novi_form(kupac **p,char ime[], int b_hleb, int b_pecivo, int b_poena)
{
	kupac *pom=*p;
	int d,s;
	int par=0;
	
	while(pom->sledeci != NULL) 
	{
		if( strcmp(pom->ime,ime)==0) 
		{
			d=b_hleb/1;
			s=b_pecivo/2;
		
			if(d < s) pom->b_poena=d; else pom->b_poena=s;
			par=1;
		}
			
		pom=pom->sledeci;
	}
	
	if(par==0) dodaj(p,ime,b_hleb,b_pecivo,b_poena);
			
}

