#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct roba
{
       char tip[20];
       char naziv[20];
       int broj;
       int balans;
       struct roba *levi, *desni;
}drvo;

#define novi(x) x=(drvo *)malloc(sizeof(drvo))

drvo *form();
void lrotacija(drvo **);
void drotacija(drvo **);
void ispis(drvo *, int);
int dodaj(drvo **, char*, char*, int);
int dubina(drvo *);
void brisi(drvo *, drvo **, char*, char*, int);
int trazi(drvo *, char*, int);

main()
{
       drvo *p, *q;
       q = NULL;
       char tip[20], naziv[20], t[20];
       int broj, k, i, pp, ima;
       p=form();
       ispis(p,1);
       printf("Dubina stabla je %d: \n", dubina(p));
       
       printf("Unesi koji tip trazis i koji broj komada: ");
       scanf("%s%d", t, &pp);
       
       ima = trazi(p, t, pp);
       printf("Ima ih:%d", ima);
       printf("\n");
       ///////////////////////////////////////////////
       printf("Unesi koliko ima narudzbenica: ");
       scanf("%d", &k);
       for(i=0; i<k; i++)
       {
	      printf("Unesi tip naziv i broj komada koji narucujes:  \n");
	      scanf("%s%s%d", tip, naziv, &broj);
	      brisi(p, &q, tip, naziv, broj);
       }
       ispis(q, 1);
       
}


drvo *form()
{
       drvo *koren;
       koren = NULL;
       char tip[20], naziv[20];
       int broj, n, i;
       printf("Unesi koliko proizvoda ima u skladistu:  ");
       scanf("%d", &n);
       for(i=0; i<n; i++)
       {
	      printf("Unesi tip proizvoda:  ");
	      scanf("%s", tip);
	      printf("Unesi naziv proizvoda:  ");
	      scanf("%s", naziv);
	      printf("Unesi broj komada:  ");
	      scanf("%d", &broj);
	    
	      dodaj(&koren, tip, naziv, broj);
       }
       return koren;
}


void lrotacija(drvo **t)
{
       drvo *poml, *pomd;
       poml = *t;
       pomd= poml->desni;
       poml->desni=pomd->levi;
       pomd->levi=poml;
       *t = pomd;
       
       poml->balans = dubina(poml->desni) - dubina(poml->levi);
       pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(drvo **t)
{
       drvo *poml, *pomd;
       pomd = *t;
       poml=pomd->levi;
       pomd->levi=poml->desni;
       poml->desni=pomd;
       *t = poml;
       
       poml->balans = dubina(poml->desni) - dubina(poml->levi);
       pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
       
}

void ispis(drvo *p, int i)
{
       if(p==NULL)
	      return;
       else
       {
	      ispis(p->levi, i+1);
	      printf("Nivo- %d.  Tip %s,  naziv %s,  broj komada %d\n", i, p->tip, p->naziv, p->broj);
	      ispis(p->desni, i+1);
       }
}

int dodaj(drvo **p, char tip[20], char naziv[20], int broj)
{
       drvo *t = *p;
       int inc, rez;
       rez=0;
       
       if(t==NULL)
       {
	      novi(t);
	      if(t==NULL)
	      {
		     printf("Greska pri alokaciji memorije\n");
		     exit(0);
	      }
	      
	      strcpy(t->tip, tip);
	      strcpy(t->naziv, naziv);
	      t->broj = broj;
	      t->levi = t->desni = NULL;
	      t->balans = 0;
	      rez = 1;
       }
       else
       {
	      if((strcmp(t->tip,tip)<=0 ) || ((strcmp(t->tip,tip)==0) && (strcmp(t->naziv, naziv)<=0)))
		     inc = dodaj(&(t->desni), tip, naziv, broj);
	      else
		     inc = -dodaj(&(t->levi), tip, naziv, broj);
	      t->balans += inc;
	      
	      
	      if(inc!=0 && t->balans!=0)
	      {
		     if(t->balans<-1)
		     {
			    if(t->levi->balans<0)
				   drotacija(&t);
			    
			    else
			    {
				   lrotacija(&(t->levi));
				   drotacija(&t);
			    }
		     }
		     else if (t->balans>1)
		     {
			    if(t->desni->balans>0)
				   lrotacija(&t);
			    else
			    {
				   drotacija(&(t->desni));
				   lrotacija(&t);
			    }
		     }
		     else rez = 1;
	      }   
       }
       *p=t;
       return rez;
}

int dubina(drvo *p)
{
       int dd = 0, dl = 0;
       if(p==NULL)
	      return 0;
       
       if(p->levi)
	      dl = dubina(p->levi);
       if(p->desni)
	      dd = dubina(p->desni);
       if(dd>dl)
	      return ++dd;
       else
	      return ++dl;
       
}

void brisi(drvo *p, drvo **q, char tip[20], char naziv[20], int broj)
{
       if((strcmp(p->tip,tip)!=0) || ((strcmp(p->naziv,tip))!=0) || p->broj>broj)
       {
	      brisi(p->desni, q, tip, naziv, broj);
	      dodaj(q, p->tip, p->naziv, p->broj);
	      brisi(p->levi, q, tip, naziv, broj);
       }    
       
}

int trazi(drvo *p, char tip[20], int broj )
{
       int br = 0;
       if(p==NULL)
	      return;
       if((strcmp(p->tip, tip)==0) && (p->broj<broj))
       {
	     if(p->levi)
		     br += trazi(p->levi, tip, broj);
	      if(p->desni)
		     br += trazi(p->desni, tip, broj);
       }
       return br;
}






