#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct li
{
	char *ime;
	int broj_hleba;
	int broj_peciva;
	int broj_poena;
	struct li *sledeci;
}lista;


#define aloc(a) a = (lista*)malloc(sizeof(lista))
#define alocs(a, s) a = (char*)malloc(strlen(s)+1)

void Ispis (lista *p)
{
	while (p)
	{
		printf("%s\t%d\t%d\t%d\n", p->ime, p->broj_hleba, p->broj_peciva, p->broj_poena);
		p = p->sledeci;
	}
}

lista* Dodaj(lista *p, char *ime, int bh, int bp, int po)
{
	lista *q, *pom = p;
	
	aloc(q);
	alocs(q->ime, ime);
	strcpy(q->ime, ime);
	q->broj_hleba = bh;
	q->broj_peciva = bp;
	q->broj_poena = po;
	q->sledeci = NULL;
	
	if (p == NULL) p = q;
	else
	{
		while (pom->sledeci) pom = pom->sledeci;
		pom->sledeci = q;
	}
	
	return p;
}		

int Broj_Poena (int bh, int bp)
{
	int broj = 0, brojh = bh, brojp = bp;
	
	while (brojh >= 1 && brojp >=2) 
	{
		broj++;
		brojh -= 1;
		brojp -= 2;
	}
	
	return broj;
}

lista* Formiraj (lista *p, FILE *f)
{
	int n, i, bh, bp, po;
	char ime[30];
	
	fscanf(f, "%d", &n);
	
	for (i = 0; i < n; i++)
	{
		fscanf(f, "%s", ime);
		fscanf(f, "%d", &bh);
		fscanf(f, "%d", &bp);
		po = Broj_Poena(bh, bp);
		p = Dodaj(p, ime, bh, bp, po);
	}
	fclose(f);
	return p;
}

int Ima_Ih (lista *p, char *ime)
{
	while (p)
	{
		if (strcmp(p->ime, ime) == 0) return 1;
		p = p->sledeci;
	}
	
	return 0;
}

lista* Naredni_Dan (lista *p, FILE *f)
{
	int n, i, bh, bp, po;
	char ime[30];
	
	fscanf(f, "%d", &n);
	
	for (i = 0; i < n; i++)
	{
		fscanf(f, "%s", ime);
		fscanf(f, "%d", &bh);
		fscanf(f, "%d", &bp);
		po = Broj_Poena(bh, bp);
		if (Ima_Ih(p, ime)) p->broj_poena += po;
		else p = Dodaj(p, ime, bh, bp, po);
	}
	return p;
}

lista* Okreni (lista *p)
{
	lista *trenutni, *sledeci, *prethodni;
	
	prethodni = NULL;
	trenutni = p;
	
	while (trenutni)
	{
		sledeci = trenutni->sledeci;
		trenutni->sledeci = prethodni;	
		prethodni = trenutni;
		trenutni = sledeci;
	}
	
	return prethodni;
}

lista* Pobednik (lista *p, int b)
{
	p = Okreni(p);
	
	while (p)
	{
		if (p->broj_poena >= b) return p;
		p = p->sledeci;
	}
	
	return NULL;
}			

int main (int argc, char *argv[])
{
	FILE *f = fopen(argv[1], "r");
	lista *p = NULL, *q = NULL;
	int d, i, b;
	
	p = Formiraj (p, f);
	
	if (p)
	{
		printf("Pocetna lista kupaca\n");
		Ispis(p);
		f = fopen(argv[2], "r");
		p = Naredni_Dan(p, f);
		printf("Lista kupaca narednog dana\n");
		
		fscanf(f, "%d", &d);
		for (i = 0; i < d; i++) 
		{
			p = Naredni_Dan(p, f);
			Ispis(p);
		}
		fclose(f);
		
		printf("Unesi B \n");
		scanf("%d", &b);
		
		q = Pobednik(p, b);
		if (q) printf("Pobednik igre je %s sa %d bodova.\n", q->ime, q->broj_poena);
		else printf("Niko nije pobedio. \n");
	}
	else printf("Lista je prazna\n");
	
	return 0;
}
