#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct proizvodi
{
	int broj;
	char tip[20], naziv[20];
	int balans;
	struct proizvodi *levi, *desni;
};

#define novi(x) x=(struct proizvodi *)malloc(sizeof(struct proizvodi))

int dubina(struct proizvodi *p)
{
	int dd=0, dl=0;
	if(p)
	{
		if(p->levi)
			dl=dubina(p->levi);
		if(p->desni)
			dd=dubina(p->desni);
		if(dd > dl)
			return dd++;
		else
			return dl++;
	}
	else
		return 0;
}

void lrotacija(struct proizvodi **p)
{
	struct proizvodi *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct proizvodi **p)
{
	struct proizvodi *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct proizvodi **p, struct proizvodi *cvor)
{
	struct proizvodi *pom;
	int rezultat, inkrement;
	rezultat=0;
	pom=*p;
	cvor->levi=cvor->desni=NULL;
	if(!pom)
	{
		rezultat=1;
	}
	else
	{
		if((strcmp(cvor->tip,pom->tip) < 0))
			inkrement=-dodaj(p,pom->levi);
		else if((strcmp(cvor->tip,pom->tip) > 0))
			inkrement=dodaj(p,pom->levi);
		else
		{
			if((strcmp(cvor->naziv,pom->naziv) < 0))
				inkrement=-dodaj(p,pom->levi);
			else
				inkrement=dodaj(p,pom->desni);
		}
		pom->balans+=inkrement;
		if ((pom->balans) && (inkrement))
		{
			if(pom->balans < -1)
			{
				if(pom->levi->balans < 0)
					drotacija(&pom);
				else
				{
					lrotacija(&(pom->desni));
					drotacija(&pom);
				}
			}
			else if(pom->balans > 1)
			{
				if(pom->desni->balans > 0)
					lrotacija(&pom);
				else
				{
					drotacija(&(pom->levi));
					lrotacija(&pom);
				}
			}
			else
				rezultat=0;
		}
	}
	*p=pom;
	return rezultat;
}

struct proizvodi * form()
{
	struct proizvodi *cvor, *koren=NULL;
	int n, i;
	char temp[20];
	printf("Unesite broj proizvoda: ");
	scanf("%d",&n);
	for(i=0; i<n; i++)
	{
		novi(cvor);
		printf("Unesite tip proizvoda: ");
		getchar();
		gets(temp);
		strcpy(cvor->tip,temp);
		printf("Unesite naziv proizvoda: ");
		gets(temp);
		strcpy(cvor->naziv,temp);
		printf("Unesite kolicinu: ");
		scanf("%d",&cvor->broj);
		dodaj(&koren,cvor);
	}
	return koren;
}

void ispis(struct proizvodi *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s - %s - %d \n",p->tip,p->naziv,p->broj);
		ispis(p->desni);
	}
}

/*int odredi(struct proizvodi *p, char t[], int p)
{
	int br=0;
	if(p)
	{
		if(p->levi)
			br=odredi(p->levi);
		if(p->desni)
			br=odredi(p->desni);
		if(!(strcmp(p->tip,t)) && (p->broj < p))
			return br++;
		else
			return br;
	}
}*/

/*void azuriranje(struct proizvodi **q, struct proizvodi *p, struct proizvodi *cvor)
{
	if(p)
	{
		azuriranje(p->levi);
		if((!(strcmp(cvor->tip))) && (!(strcmp(cvor->naziv,p->naziv))) && (cvor->broj < p->broj))
		{
			cvor->broj=(p->broj-cvor->broj);
			dodaj(q,p);
		}
		azuriranje(p->desni);
	}
}*/
		
main()
{
	char t[20], i[20];
	int broj, k, j;
	struct proizvodi *koren=NULL, *novi_koren=NULL, *cvor;
	koren=form();
	ispis(koren);
	/*printf("Unesite broj narudzbenica: ");
	scanf("%d",&k);
	for(i=0; i<k; i++)
	{
		novi(cvor);
		printf("Unesite tip proizvoda: ");
		getchar();
		gets(t);
		printf("Unesite naziv proizvoda: ");
		gets(i);
		printf("Unesite broj proizvodda: ");
		scanf("%d",&cvor->broj);
		strcpy(cvor->tip,t);
		strcpy(cvor->naziv,i);
		azuriranje(&novi_koren,koren,cvor);
	}*/
	
}
