# include <stdio.h>
# include <stdlib.h>
# include <string.h>

struct proizvod
{
	char *tip;
	char *naziv;
	int broj;
	int balans;
	struct proizvod *levi,*desni;
};


int dubina(struct proizvod *p)
{
	if(p=NULL) return 0;
	int a=1+dubina(p->levi);
	int b=1+dubina(p->desni);
	if(a>b) return a;
	else return b;
}

void l_rotacija(struct proizvod **p)
{
	struct proizvod *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;

	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void d_rotacija(struct proizvod **p)
{
	struct proizvod *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;

	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct proizvod **p,char tip[],char naziv[], int broj)
{
	struct proizvod *t;
	t=*p;
	int inkrement,rezultat=0;
	if(p==NULL)
	{
		t=(struct proizvod *)malloc(sizeof(struct proizvod));
		if(t==NULL)
		{
			printf("Greska");
			exit(0);
		}
		t->tip=(char *)malloc(strlen(tip)+1);
		strcpy(t->tip,tip);

		t->naziv=(char *)malloc(strlen(naziv)+1);
		strcpy(t->naziv,naziv);
		t->broj=broj;
		t->balans=0;
		t->levi=t->desni=NULL;
		rezultat=1;
	}
	else
	{
		if(strcmp(t->tip,tip)==0)
		{
			if(strcmp(naziv,t->naziv)>=0)
				inkrement=dodaj(&(t->desni),t->tip,t->naziv,t->broj);
			else
				inkrement=-dodaj(&(t->levi),t->tip,t->naziv,t->broj);
		}
		else
		{
			if(strcmp(tip,t->tip)>=0)
				inkrement=dodaj(&(t->desni),t->tip,t->naziv,t->broj);
			else
				inkrement=-dodaj(&(t->levi),t->tip,t->naziv,t->broj);
		}
		t->balans+=inkrement;
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans<-1)
			{
				if(t->levi->balans<0) d_rotacija(&t);
				else
				{
					l_rotacija(&(t->levi));
					d_rotacija(&t);
				}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) l_rotacija(&t);
				else
				{
					d_rotacija(&(t->desni));
					l_rotacija(&t);
				}
			}
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

void ispis(struct proizvod *p)
{
	if(p==NULL) return;
	ispis(p->levi);
	printf("%s %s %d\n",p->tip,p->naziv,p->broj);
	ispis(p->desni);
}

struct proizvod *form()
{
	struct proizvod *koren;
	char tip[20];
	char naziv[20];
	int broj;
	koren=NULL;
	int i,n,j;
	printf("Unesi n\n");
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		printf("Unesi tip\n");
		scanf("%s",&tip);
		printf("unesi naziv\n");
		scanf("%s",&naziv);
		printf("Unesi broj\n");
		scanf("%d",broj);
		j=dodaj(&koren,tip,naziv,broj);
	}
	return koren;
}

main()
{
	struct proizvod *p;
	p=form();
	ispis(p);
}
