#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista_s
{
    char *IME;
    int B_HLEB;
    int B_PECIVO;
    int B_POENA;
    struct lista_s *rep;
}lista;

void dodaj (lista **p,char *ime, int b_hleb, int b_pecivo, int b_poena)
{
    lista *t = (lista*)malloc(sizeof(lista));
    if(!t)
    {
        printf("Greska pri alociranju\n");
        exit(1);
    }

    t->IME = (char*)malloc(sizeof(ime) + 1);
    strcpy(t->IME, ime);
    t->B_HLEB = b_hleb;
    t->B_PECIVO = b_pecivo;
    t->B_POENA = b_poena;

    t->rep = NULL;

    if((*p)==NULL) *p = t;
    else
    {
        lista *pom = *p;
        while(pom->rep) pom = pom->rep;
        pom->rep = t;
    }

}

lista* form()
{
    lista *p = NULL;

    char ime[100];
    int b_hleb, b_pecivo, b_poena;
    int n;

    scanf("%d", &n);
    int i;

    for(i=0; i<n;i++)
    {
        scanf("%s%d%d",ime,&b_hleb, &b_pecivo);

        if(b_hleb < (b_pecivo/2))
            b_poena = b_hleb;
        else
            b_poena = b_pecivo/2;
        dodaj(&p, ime, b_hleb, b_pecivo, b_poena);
    }

    return p;
}

void ispis(lista *p)
{
    if (!p)
    {
        printf("Lista je prazna.\n");
        return;
    }

    while(p)
    {
        printf("%s %d %d %d\n", p->IME, p->B_HLEB, p->B_PECIVO, p->B_POENA);
        p=p->rep;
    }
    printf("\n");
}

void radi_za_d_dana(lista **p, char *ime, int b_hleb, int b_pecivo)
{
    int novi = 1;

    lista *pom = *p;

    //prodji kroz celu listu
    //ako ga nadjes u listi ---> novi = 0
    while(pom)
    {
        if (!strcmp(ime,pom->IME))
        {
            novi = 0;
            break;
        }

        pom=pom->rep;
    }

    // ako treba da se azuriraju podaci samo
    // jer taj postoji vec u listi

    if (novi == 0)
    {
        //nadji ga u listi
        pom = *p;
        while(pom)
        {
            //ako je to taj
            if(!strcmp(ime, pom->IME))
            {
                //dodaj mu poene, azuriraj b_poena
                pom->B_HLEB += b_hleb;
                pom->B_PECIVO += b_pecivo;

                if( pom->B_HLEB < (pom->B_PECIVO / 2) )
                    pom->B_POENA = pom->B_HLEB;
                else
                    pom->B_POENA = (pom->B_PECIVO / 2);

            }
        }
    }
    // novi je ostao 1
    //znaci treba da se doda na kraj liste
    else
    {
        //odredi mu prvo koliko ima poena
        //pa ga dodaj
        int b_poena;
        if(b_hleb < (b_pecivo/2))
            b_poena = b_hleb;
        else
            b_poena = b_pecivo/2;
        dodaj(p, ime, b_hleb,b_pecivo,b_poena);
    }
}


int f(lista *p, char **pobednik, int b)
{
    //Nagradu dobija kupac koji je poslednji u listi
    // i koji je sakupio bar B bodova, pri čemu se B zadaje na ulazu.

    // elementi su se dodavlai na kraj--> poslednji je na kraju
    //idi od pocetka do kraja liste
    //ako je uslov u bilom kom prolazu tacan
    //azuriraj pobednika i pp stavi na 1

    //nemamo pobednika
    int pp = 0;

    while(p)
    {
        if(p->B_POENA >= b)
        {
            strcpy(*pobednik, p->IME);
            pp = 1;
        }
        p=p->rep;
    }

    return pp;

}

int main(void)
{
    lista *p = form();
    printf("Lista kupaca posle prvog dana:\n");
    ispis(p);

    int d, k;
    scanf("%d%d", &d, &k);

    int i;
    char ime[100];
    int b_hleb, b_pecivo;

    int r = 0;
    while(r < d-1)
    {

        for(i = 0; i <k; i++)
        {
        scanf("%s%d%d", ime, &b_hleb, &b_pecivo);
        radi_za_d_dana(&p, ime, b_hleb, b_pecivo);
        printf("Lista kupaca na kraju %d dana:\n", i+2);
        ispis(p);
        }
        r++;
     }


    int b; scanf("%d", &b);
    char *pobednik = (char*)malloc(100*sizeof(char));

    int ima = f(p, &pobednik, b);
    // f vraca 1 ako nadje nekog
    // 0 inace

    if(ima)
        printf("\nPobednik je %s \n", pobednik);
    else
        printf("\nNiko nema barem %d bodova, pa nema ni pobednika.\n", b);



    return 0;
}

