#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct roba
{
	char tip[50];
	char naziv[50];
	int broj;
	int balans;
	struct roba *levi, *desni;
};

#define novi(x) x=(struct roba *)malloc(sizeof(struct roba))

int dubina(struct roba *p);
void lrotacija(struct roba **p);
void drotacija(struct roba **p);
struct roba *formiraj(void);
void ispis(struct roba *p);
int dodaj(struct roba **p, struct roba *q);
void raz(struct roba *p, int *k, char *t, int bp);
void sredi(struct roba **p);
void brisi(struct roba **p, int k);

int main(void)
{
	struct roba *p;
	p=formiraj();
	ispis(p);
	printf("------------\n");
	int k;
	printf("Unesite broj k:\n");
	scanf("%d",&k);
	getchar();
	brisi(&p,k);
	int bk=0,bp;
	char t[50];
	printf("Unesite tip t: ");
	scanf("%s",t);
	printf("Unesite broj bp: ");
	scanf("%d",&bp);
	raz(p,&bk,t,bp);
	printf("Broj razlicitih proizvoda zadatog tipa t ima: %d\n",bk);
	return 0;
}

int dubina(struct roba *p)
{
	int dl=0, dd=0;
	if (p)
	{
		if (dl>dd)
			dl=dubina(p->levi);
		else
			dd=dubina(p->desni);
	}
	if (dl>dd)
		return dl++;
	else
		return dd++;
}

void lrotacija(struct roba **p)
{
	struct roba *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->desni;
	pomd->levi=poml;
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	*p=pomd;
}

void drotacija(struct roba **p)
{
	struct roba *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	*p=poml;
}

struct roba *formiraj(void)
{
	struct roba *p=NULL, *temp;
	int n;
	scanf("%d",&n);
	getchar();
	while (n--)
	{
		novi(temp);
		scanf("%s",temp->tip);
		scanf("%s",temp->naziv);
		scanf("%d",&(temp->broj));
		getchar();
		temp->levi=temp->desni=NULL;
		dodaj(&p,temp);
	}
	return p;
}

void ispis(struct roba *p)
{
	if (p)
	{
		if (p->levi)
			ispis(p->levi);
		printf("Tip: %s\n",p->tip);
		printf("Naziv: %s\n",p->naziv);
		printf("Broj: %d\n",p->broj);
		if (p->desni)
			ispis(p->desni);
	}
}

int dodaj(struct roba **p, struct roba *q)
{
	struct roba *temp, *t;
	int rez=0, ink;
	t=*p;
	if (!t)
	{
		*p=q;
		(*p)->balans=0;
		rez=1;	
	}
	else
	{
		if (strcmp(t->tip,q->tip)<0)
			ink=-dodaj(&(t->levi),q);
		else if (strcmp(t->tip,q->tip)>0)
			ink=dodaj(&(t->desni),q);
		else
		{
			if (strcmp(t->naziv,q->naziv)<0)
				ink=-dodaj(&(t->levi),q);
			else
				ink=-dodaj(&(t->desni),q);	
		}
		t->balans+=ink;
		if (ink!=0 && t->balans!=0)
		{
			if (t->balans<-1)
			{
				if (t->levi->balans<0)
					drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if (t->balans>1)
			{
				if (t->desni->balans>0)
					lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else
				rez=1;
		}	
	}
	return rez;
}


void raz(struct roba *p, int *k, char *t, int bp)
{
	if (p)
	{
		if (!strcmp(p->tip,t) && p->broj<bp)
			++*k;
		if (p->levi)
			raz(p->levi,k,t,bp);
		if (p->desni)
			raz(p->desni,k,t,bp);
	}
}
void brisi(struct roba **p, int k)
{
	char tip[50], naziv[50];
	int broj;
	int i;
	struct roba *pom;
	for (i=0; i<k; i++)
	{
		scanf("%s",tip);
		scanf("%s",naziv);
		scanf("%d",&broj);
		pom=*p;
		while (1)
		{
			if (pom && !strcmp(pom->tip,tip) && !strcmp(pom->naziv,naziv))
				break;
			if (pom && strcmp(pom->tip,tip)<0)
				pom=pom->levi;
			else if (pom && strcmp(pom->tip,tip)>0)
				pom=pom->levi;
			else
			{
				if (pom && strcmp(pom->naziv,naziv)<0)
					pom=pom->levi;
				else if (pom && strcmp(pom->naziv,naziv)>0)
					pom=pom->desni;
			}
		}
	}
}

void sredi(struct roba **p)
{
	
}
